library IEEE;
   use IEEE.std_logic_1164.all;
   use IEEE.std_logic_unsigned.all;
   use ieee.std_logic_arith.all;

library work;
   use work.all;

entity fsm_tb is
end fsm_tb;

architecture fsm_arch_tb of fsm_tb is
component dsmc_demo_FSM is
       port (  
--	//////////// CLOCK //////////
	CLOCK_50 		: IN STD_LOGIC;
--	//////////// LED //////////
	LED			:OUT STD_LOGIC_VECTOR(7 downto 0);
--	//////////// GPIO_0, GPIO_0 connect to GPIO Default //////////
	GPIO_0			:IN STD_LOGIC_VECTOR(33 downto 0);
	GPIO_0_IN 		:IN STD_LOGIC_VECTOR(1 downto 0)
);
	
end component;                                                         

signal clock: std_logic :='1';
signal led_s: std_logic_vector(7 downto 0);
signal GPIO0: std_logic_vector(33 downto 0);
signal GPIO0IN: std_logic_vector(1 downto 0);
-- constant num_cycles : integer := 320;
constant clk_period : time := 10 ns;

begin   

cnt_inst: dsmc_demo_FSM
      port map (                                                            
                clock, led_s, GPIO0, GPIO0IN );

clk_gen: process is
begin
        clock <= '1';
        wait for clk_period/2;  --for 0.5 ns signal is '0'.
        clock <= '0';
        wait for clk_period/2;  --for next 0.5 ns signal is '1'.
end process clk_gen;

trig: process is
begin
         GPIO0(13)<= '1';
         GPIO0(0) <= '0';
         wait for clk_period*10;
         GPIO0(13) <= '0';
         GPIO0(0)<= '1';
	 wait for clk_period;
         GPIO0(0)<= '0';
         wait for clk_period*10;
         GPIO0(0)<= '1';
	 wait for clk_period;
         GPIO0(0)<= '0';
         
	 wait for clk_period;
	 wait;
end process trig;

end architecture fsm_arch_tb;

